﻿using Wisej.Web;
using BindingTests.Model;

namespace BindingTests.Views
{
    public partial class AllBindings : Form
    {
        private Vendor _vendor;

        public AllBindings()
        {
            InitializeComponent();

			this.vendorListBindingSource.ListChanged += VendorListBindingSource_ListChanged;
			this.vendorBindingSource.ListChanged += VendorBindingSource_ListChanged;
        }

		private void VendorListBindingSource_ListChanged(object sender, System.ComponentModel.ListChangedEventArgs e)
		{
		}

		private void VendorBindingSource_ListChanged(object sender, System.ComponentModel.ListChangedEventArgs e)
		{
		}

		private void DataGridBinding_Load(object sender, System.EventArgs e)
        {
            vendorListBindingSource.DataSource = VendorList.GetVendorList();
        }

        private void newButton_Click(object sender, System.EventArgs e)
        {
            GetNewVendor();
        }

        private void saveButton_Click(object sender, System.EventArgs e)
        {
            _vendor?.Save();
        }

        private void removeButton_Click(object sender, System.EventArgs e)
        {
            _vendor?.Delete();
        }

        private void GetNewVendor()
        {
            _vendor = new Vendor();
            vendorBindingSource.DataSource = _vendor;
        }

        private void dataGridView_SelectionChanged(object sender, System.EventArgs e)
        {
            BindLine();
        }

        private void BindLine()
        {
			_vendor = null;

			if (dataGridView.SelectedRows.Count > 0)
            {
				if (!dataGridView.SelectedRows[0].IsNewRow)
				{
					var id = (int)dataGridView.SelectedRows[0].Cells[0].Value;
					_vendor = VendorList.GetVendor(id);
					vendorBindingSource.DataSource = _vendor;
				}
            }
        }
    }
}